﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace ClientWebServiceRestGestionListe
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Construction de l'URL
            string uri = "http://localhost:8080/WebServiceRESTGestionListe/resources/GestionListe/creerlistPersonne/" + textBox1.Text;

            // Appel de la méthode permettant d'envoyer et de revevoir des données
            string reponse = envoieEtReceptionDonneesAvecHttpWebResponse(uri, "POST");

            // Affichage sur l'interface graphique
            richTextBox1.Text += reponse;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // Construction de l'URL
            string uri = "http://localhost:8080/WebServiceRESTGestionListe/resources/GestionListe/ajouterpersonnedanslistepersonne/" + textBox2.Text + "/ajoutPersonne/" + textBox3.Text + "-" + textBox4.Text;

            // Appel de la méthode permettant d'envoyer et de revevoir des données
            string reponse = envoieEtReceptionDonneesAvecHttpWebResponse(uri, "POST");

            // Affichage sur l'interface graphique
            richTextBox1.Text += "\n" + reponse;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            // Construction de l'URL
            string uri = "http://localhost:8080/WebServiceRESTGestionListe/resources/GestionListe/consulterpersonnedanslistepersonne/" + textBox5.Text + "-" + textBox6.Text;

            // Appel de la méthode permettant d'envoyer et de revevoir des données
            String reponse = envoieEtReceptionDonneesAvecHttpWebResponse(uri, "GET");

            // Affichage sur l'interface graphique
            richTextBox1.Text += "\n" + reponse;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            // Construction de l'URL
            string uri = "http://localhost:8080/WebServiceRESTGestionListe/resources/GestionListe/consulterlistepersonne/" + textBox7.Text;

            // Appel de la méthode permettant d'envoyer et de revevoir des données
            String reponse = envoieEtReceptionDonneesAvecHttpWebResponse(uri, "GET");

            // Affichage sur l'interface graphique
            richTextBox1.Text += "\n" + reponse;
        }

        // Méthode permettant d'envoyer et de recevoir des données provenant
        // des web services grâce à la bibliothèque HTTPWebRequest
        private String envoieEtReceptionDonneesAvecHttpWebResponse(string URL, string Method)
        {
            string retour = null;
            try
            {
                // Construction de la requête à envoyer
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(URL);

                // Détermination de la méthode HTTP à appeler
                request.Method = Method;
                request.Credentials = CredentialCache.DefaultCredentials;

                // Declenchement de l'appel du web service
                HttpWebResponse response = (HttpWebResponse)request.GetResponse();

                // Récupérer le stream associé à la résponse
                Stream receiveStream = response.GetResponseStream();

                // Précision du codage 
                StreamReader readStream = new StreamReader(receiveStream, Encoding.UTF8);

                // Récupérer le résultat en format string
                retour = readStream.ReadToEnd();

                // Fermer les sessions
                response.Close();
                readStream.Close();
            }
            catch (Exception ex)
            {
                retour = ex.ToString();
            }

            return retour;
        }
    }
}
